package edu.berkeley.cs.cs162;

import java.util.HashMap;

/**
   The Launcher contains the main() method. Launcher should be started by
   calling 'java Launcher <filename>', where filename is the name of the
   configuration file containing Game, Player, and Observer configurations.

   The Launcher will create a single new GameServer, load configuration settings
   from the specified file, and wait for the configured games to run and finish.
 */
class Launcher {

    /**
       Loads information from the configuration file and creates all the
       specified Players, Observers, and Boards. For each game, ask the server
       to create and start running that game using GameServer.createGame(). Note
       that it should be possible to have some games running and finishing while
       others have not been created yet.

       The configuration file should have the following format:

       Player <PlayerClassName> <PlayerName>
       ...
       Observer <ObserverClassName> <ObserverName>
       ...
       Game <GameName> <BlackPlayerName> <WhitePlayerName> <BoardSize> <TimeoutInMs> <Observers>

       You may also assume that all Player and Observer lines come before all
       Game lines in the file. Threads should be created and started for all
       players and observers specified in the configuration file, and provided
       back to the caller in the observerThreads map.
     */
    public static void loadFromConfigurationFile(String filename, GameServer server, HashMap<Observer, Thread> observerThreads) {
	// TODO: implement me
    }

    public static void exitAndJoinAllThreads(Thread serverThread, HashMap<Observer, Thread> observerThreads) {
	// TODO: implement me
    }
    
    public static void main(String[] args) {
	if (args.length != 1) {
	    System.err.println("Wrong number of args: should be 'java Launcher <filename>'");
	    return;
	}
	
	GameServer server = new GameServer();
	Thread serverThread = new Thread(server);
	HashMap<Observer, Thread> observerThreads = new HashMap<Observer, Thread>();
	serverThread.start();
	loadFromConfigurationFile(args[0], server, observerThreads);
	server.waitForGames();
	exitAndJoinAllThreads(serverThread, observerThreads);
    }
    
}
