package edu.berkeley.cs.cs162;

/**
   A wrapper for a location on the board. x,y represent the coordinates of a
   position on the board.
 */

public class Location {
    private int x, y;

    public Location(int x, int y) {
	this.x = x;
	this.y = y;
    }

    public int getX() { return x; }
    public int getY() { return y; }

    public boolean equals(Object other) {
	if (other instanceof Location) {
	    Location otherLocation = (Location)other;
	    return this.x == otherLocation.x && this.y == otherLocation.y;
	} else {
	    return false;
	}
    }

    public int hashCode() {
	return x + 101*y;
    }

    public String toString() {
	return "(" + getX() + "," + getY() + ")";
    }
}
