package edu.berkeley.cs.cs162;

/**
   A Player is a special Observer that can also play in games. Each player must maintain
   its own private board state, and cannot directly access the Game's board or any other
   Player's board.

   Players will be initialized with a server and a unique name. Interaction with the Game
   object in any way must be done through the server.
 */
public abstract class Player extends Observer {
    GameServer server;

    /* Sets the this player's server. */
    public void setServer(GameServer server) { this.server = server; }
    
    public abstract Board getBoard();
}
